Loading...
Searching...
No Matches
elastix::MultiMetricMultiResolutionRegistration< TElastix > Class Template Reference
Components » Registrations

`#include <elxMultiMetricMultiResolutionRegistration.h>`

## Detailed Description

template<class TElastix>
class elastix::MultiMetricMultiResolutionRegistration< TElastix >

A registration framework based on the itk::MultiMetricMultiResolutionImageRegistrationMethod.

This MultiMetricMultiResolutionRegistration gives a framework for registration with a multi-resolution approach, using multiple metrics. The metrics can use the same pair of images/image pyramids/interpolators /masks, but also different pairs of fixed/moving images etc. If the metrics use the same moving image and the same moving image pyramid, they can use the same interpolator. If multiple moving images are used, enter multiple interpolators, possibly of the same type: Like this for example:
(Interpolator "BSplineInterpolator" "BSplineInterpolator")
For each metric a different instance of an image sampler can be used:
(ImageSampler "Random" "Random")
or:
(ImageSampler "Random" "Full")
Note, that the number of metrics should always be larger than or equal to the number of fixed/moving images, interpolators, image pyramids etc. Also, when all metrics need an image sampler, for each fixed image pyramid, an image sampler must be provided. In some cases, one sampler can be used for all metrics. This is the case when multiple metrics are desired, but

- 1 fixed image is used, and
- 1 fixed image pyramid is used. This will save a bit of memory and computation time. In general however, it is better to use the same number of samplers as metrics.

The parameters used in this class are:

Parameters

  Registration: Select this registration framework as follows:
  (Registration "MultiMetricMultiResolutionRegistration")

  NumberOfResolutions: the number of resolutions used.
  example: (NumberOfResolutions 4)
  The default is 3.

  Metric<i>Weight: The weight for the i-th metric, in each resolution.
  example: (Metric0Weight 0.5 0.5 0.8)
  example: (Metric1Weight 0.5 0.5 0.2)
  The default is 1 / numberOfMetrics.

  Metric<i>RelativeWeight: The relative weight for the i-th metric, in each resolution.
  This is an alternative to the default Metric<i>Weight and can be selected with the parameter UseRelativeWeights. The weight is computed in each iteration based on the magnitude of the metric derivative (gradient) related to that of the first metric . It is done such that the fraction is identical to , so

example: (Metric0RelativeWeight 0.5 0.5 0.8)
example: (Metric1RelativeWeight 0.5 0.5 0.2)
The default is 1 / numberOfMetrics.

Parameters

  UseRelativeWeights: Whether relative weights are used or simple static, fixed weights.
  example: (UseRelativeWeights "false" "true")
  The default is "false", which means using Metric<i>Weight.

  Metric<i>Use: Whether the i-th metric is only computed or also used, in each resolution.
  example: (Metric0Use "false" "true")
  example: (Metric1Use "true" "false")
  The default is "true".

Definition at line 95 of file elxMultiMetricMultiResolutionRegistration.h.

Inheritance diagram for elastix::MultiMetricMultiResolutionRegistration< TElastix >:
[legend]

## Public Types

using | ConstPointer = itk::SmartPointer<const Self>
using | ITKBaseType = typename Superclass2::ITKBaseType
using | Pointer = itk::SmartPointer<Self>
using | RegistrationType = typename Superclass2::RegistrationType
using | Self = MultiMetricMultiResolutionRegistration
using | Superclass1
using | Superclass2 = RegistrationBase<TElastix>
using | UseMaskErosionArrayType
Public Types inherited from itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >
using | CombinationMetricPointer = typename CombinationMetricType::Pointer
using | CombinationMetricType = CombinationImageToImageMetric<FixedImageType, MovingImageType>
using | ConstPointer = SmartPointer<const Self>
using | DataObjectPointer
using | FixedImageConstPointer
using | FixedImagePyramidPointer
using | FixedImagePyramidType
using | FixedImageRegionType
using | FixedImageType
using | InterpolatorPointer
using | InterpolatorType
using | MetricPointer
using | MetricType
using | MovingImageConstPointer
using | MovingImagePyramidPointer
using | MovingImagePyramidType
using | MovingImageType
using | OptimizerPointer = typename OptimizerType::Pointer
using | OptimizerType
using | ParametersType
using | Pointer = SmartPointer<Self>
using | Self = MultiMetricMultiResolutionImageRegistrationMethod
using | Superclass = MultiResolutionImageRegistrationMethod2<TFixedImage, TMovingImage>
using | TransformOutputConstPointer
using | TransformOutputPointer
using | TransformOutputType
using | TransformPointer
using | TransformType
Public Types inherited from itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >
using | ConstPointer = SmartPointer<const Self>
using | DataObjectPointer = typename DataObject::Pointer
using | FixedImageConstPointer = typename FixedImageType::ConstPointer
using | FixedImagePyramidPointer = typename FixedImagePyramidType::Pointer
using | FixedImagePyramidType = MultiResolutionPyramidImageFilter<FixedImageType, FixedImageType>
using | FixedImageRegionPyramidType = std::vector<FixedImageRegionType>
using | FixedImageRegionType = typename FixedImageType::RegionType
using | FixedImageType = TFixedImage
using | InterpolatorPointer = typename InterpolatorType::Pointer
using | InterpolatorType = typename MetricType::InterpolatorType
using | MetricPointer = typename MetricType::Pointer
using | MetricType = AdvancedImageToImageMetric<FixedImageType, MovingImageType>
using | MovingImageConstPointer = typename MovingImageType::ConstPointer
using | MovingImagePyramidPointer = typename MovingImagePyramidType::Pointer
using | MovingImagePyramidType = MultiResolutionPyramidImageFilter<MovingImageType, MovingImageType>
using | MovingImageType = TMovingImage
using | OptimizerType = SingleValuedNonLinearOptimizer
using | ParametersType = typename MetricType::TransformParametersType
using | Pointer = SmartPointer<Self>
using | Self = MultiResolutionImageRegistrationMethod2
using | Superclass = ProcessObject
using | TransformOutputConstPointer = typename TransformOutputType::ConstPointer
using | TransformOutputPointer = typename TransformOutputType::Pointer
using | TransformOutputType = DataObjectDecorator<TransformType>
using | TransformPointer = typename TransformType::Pointer
using | TransformType = typename MetricType::AdvancedTransformType
Public Types inherited from elastix::RegistrationBase< TElastix >
using | ElastixType
using | FixedImageType = typename ElastixType::FixedImageType
using | ITKBaseType = itk::MultiResolutionImageRegistrationMethod2<FixedImageType, MovingImageType>
using | MovingImageType = typename ElastixType::MovingImageType
using | RegistrationType
using | Self = RegistrationBase
using | Superclass = BaseComponentSE<TElastix>
using | UseMaskErosionArrayType = std::vector<bool>
Public Types inherited from elastix::BaseComponentSE< TElastix >
using | ElastixType = TElastix
using | RegistrationType = typename ElastixType::RegistrationBaseType
using | Self = BaseComponentSE
using | Superclass = BaseComponent

## Public Member Functions

void | AfterEachIteration () override
void | BeforeEachResolution () override
void | BeforeRegistration () override
| elxClassNameMacro ("MultiMetricMultiResolutionRegistration")
virtual const char * | GetClassName () const
| ITK_DISALLOW_COPY_AND_MOVE (MultiMetricMultiResolutionRegistration)
| itkStaticConstMacro (FixedImageDimension, unsigned int, Superclass2::FixedImageDimension)
| itkStaticConstMacro (MovingImageDimension, unsigned int, Superclass2::MovingImageDimension)
Public Member Functions inherited from itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >
| elxOverrideSimpleSetMacro (FixedImage, const FixedImageType *)
| elxOverrideSimpleSetMacro (FixedImagePyramid, FixedImagePyramidType *)
| elxOverrideSimpleSetMacro (FixedImageRegion, const FixedImageRegionType)
| elxOverrideSimpleSetMacro (Interpolator, InterpolatorType *)
| elxOverrideSimpleSetMacro (MovingImage, const MovingImageType *)
| elxOverrideSimpleSetMacro (MovingImagePyramid, MovingImagePyramidType *)
virtual CombinationMetricType * | GetCombinationMetric () const
const FixedImageType * | GetFixedImage () const override
virtual const FixedImageType * | GetFixedImage (unsigned int pos) const
const FixedImagePyramidType * | GetFixedImagePyramid () const override
FixedImagePyramidType * | GetFixedImagePyramid () override
virtual FixedImagePyramidType * | GetFixedImagePyramid (unsigned int pos) const
const FixedImageRegionType & | GetFixedImageRegion () const override
virtual const FixedImageRegionType & | GetFixedImageRegion (unsigned int pos) const
const InterpolatorType * | GetInterpolator () const override
InterpolatorType * | GetInterpolator () override
virtual InterpolatorType * | GetInterpolator (unsigned int pos) const
const ParametersType & | GetLastTransformParameters () const override
const MovingImageType * | GetMovingImage () const override
virtual const MovingImageType * | GetMovingImage (unsigned int pos) const
const MovingImagePyramidType * | GetMovingImagePyramid () const override
MovingImagePyramidType * | GetMovingImagePyramid () override
virtual MovingImagePyramidType * | GetMovingImagePyramid (unsigned int pos) const
ModifiedTimeType | GetMTime () const override
| ITK_DISALLOW_COPY_AND_MOVE (MultiMetricMultiResolutionImageRegistrationMethod)
| itkGetNumberOfMacro (FixedImage)
| itkGetNumberOfMacro (FixedImagePyramid)
| itkGetNumberOfMacro (FixedImageRegion)
| itkGetNumberOfMacro (Interpolator)
| itkGetNumberOfMacro (MovingImage)
| itkGetNumberOfMacro (MovingImagePyramid)
| itkSetNumberOfMacro (FixedImage)
| itkSetNumberOfMacro (FixedImagePyramid)
| itkSetNumberOfMacro (FixedImageRegion)
| itkSetNumberOfMacro (Interpolator)
| itkSetNumberOfMacro (MovingImage)
| itkSetNumberOfMacro (MovingImagePyramid)
virtual void | SetFixedImage (const FixedImageType *_arg, unsigned int pos)
virtual void | SetFixedImagePyramid (FixedImagePyramidType *_arg, unsigned int pos)
virtual void | SetFixedImageRegion (FixedImageRegionType _arg, unsigned int pos)
virtual void | SetInterpolator (InterpolatorType *_arg, unsigned int pos)
void | SetMetric (MetricType *_arg) override
virtual void | SetMovingImage (const MovingImageType *_arg, unsigned int pos)
virtual void | SetMovingImagePyramid (MovingImagePyramidType *_arg, unsigned int pos)
virtual void | StopMultiMetricRegistration ()
Public Member Functions inherited from itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >
virtual unsigned long | GetCurrentLevel () const
virtual const FixedImageType * | GetFixedImage ()
virtual const FixedImageRegionType & | GetFixedImageRegion ()
virtual const ParametersType & | GetInitialTransformParameters ()
virtual const ParametersType & | GetInitialTransformParametersOfNextLevel ()
virtual const ParametersType & | GetLastTransformParameters ()
virtual const MovingImageType * | GetMovingImage ()
ModifiedTimeType | GetMTime () const override
virtual unsigned long | GetNumberOfLevels () const
const TransformOutputType * | GetOutput () const
| ITK_DISALLOW_COPY_AND_MOVE (MultiResolutionImageRegistrationMethod2)
| itkGetModifiableObjectMacro (FixedImagePyramid, FixedImagePyramidType)
| itkGetModifiableObjectMacro (Interpolator, InterpolatorType)
| itkGetModifiableObjectMacro (Metric, MetricType)
| itkGetModifiableObjectMacro (MovingImagePyramid, MovingImagePyramidType)
| itkGetModifiableObjectMacro (Optimizer, OptimizerType)
| itkGetModifiableObjectMacro (Transform, TransformType)
DataObjectPointer | MakeOutput (ProcessObject::DataObjectPointerArraySizeType idx) override
virtual void | SetFixedImage (const FixedImageType *_arg)
virtual void | SetFixedImagePyramid (FixedImagePyramidType *_arg)
virtual void | SetFixedImageRegion (FixedImageRegionType _arg)
virtual void | SetInitialTransformParameters (ParametersType _arg)
virtual void | SetInitialTransformParametersOfNextLevel (ParametersType _arg)
virtual void | SetInterpolator (InterpolatorType *_arg)
virtual void | SetMovingImage (const MovingImageType *_arg)
virtual void | SetMovingImagePyramid (MovingImagePyramidType *_arg)
virtual void | SetNumberOfLevels (unsigned long _arg)
virtual void | SetOptimizer (OptimizerType *_arg)
virtual void | SetTransform (TransformType *_arg)
virtual void | StartRegistration ()
virtual void | StopRegistration ()
Public Member Functions inherited from elastix::RegistrationBase< TElastix >
ITKBaseType * | GetAsITKBaseType ()
const ITKBaseType * | GetAsITKBaseType () const
| ITK_DISALLOW_COPY_AND_MOVE (RegistrationBase)
| itkStaticConstMacro (FixedImageDimension, unsigned int, FixedImageType::ImageDimension)
| itkStaticConstMacro (MovingImageDimension, unsigned int, MovingImageType::ImageDimension)
virtual bool | ReadMaskParameters (UseMaskErosionArrayType &useMaskErosionArray, const unsigned int nrOfMasks, const std::string &whichMask, const unsigned int level) const
Public Member Functions inherited from elastix::BaseComponentSE< TElastix >
void | AddTargetCellToIterationInfo (const char *const name)
const Configuration * | GetConfiguration () const
ElastixType * | GetElastix () const
auto & | GetIterationInfoAt (const char *const name)
RegistrationType * | GetRegistration () const
| ITK_DISALLOW_COPY_AND_MOVE (BaseComponentSE)
void | RemoveTargetCellFromIterationInfo (const char *const name)
void | SetConfiguration (const Configuration *_arg)
void | SetElastix (ElastixType *_arg)
Public Member Functions inherited from elastix::BaseComponent
virtual void | AfterEachIterationBase ()
virtual void | AfterEachResolution ()
virtual void | AfterEachResolutionBase ()
virtual void | AfterRegistration ()
virtual void | AfterRegistrationBase ()
virtual int | BeforeAll ()
virtual int | BeforeAllBase ()
virtual void | BeforeEachResolutionBase ()
virtual void | BeforeRegistrationBase ()
virtual const char * | elxGetClassName () const
const char * | GetComponentLabel () const
| ITK_DISALLOW_COPY_AND_MOVE (BaseComponent)
| itkTypeMacroNoParent (BaseComponent)
void | SetComponentLabel (const char *label, unsigned int idx)

## Static Public Member Functions

static Pointer | New ()
Static Public Member Functions inherited from itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >
static Pointer | New ()
Static Public Member Functions inherited from itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >
static Pointer | New ()
Static Public Member Functions inherited from elastix::BaseComponent
template<typename TBaseComponent>
static auto | AsITKBaseType (TBaseComponent *const baseComponent) -> decltype(baseComponent->GetAsITKBaseType())
static void | InitializeElastixExecutable ()
static bool | IsElastixLibrary ()

## Protected Types

using | FixedMaskImagePointer
using | FixedMaskImageType
using | FixedMaskSpatialObjectPointer
using | FixedMaskSpatialObjectType
using | MaskPixelType
using | MovingMaskImagePointer
using | MovingMaskImageType
using | MovingMaskSpatialObjectPointer
using | MovingMaskSpatialObjectType
Protected Types inherited from itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >
using | FixedImageRegionPyramidType = std::vector<FixedImageRegionType>
Protected Types inherited from elastix::RegistrationBase< TElastix >
using | FixedImagePyramidType = typename ITKBaseType::FixedImagePyramidType
using | FixedMaskErodeFilterPointer = typename FixedMaskErodeFilterType::Pointer
using | FixedMaskErodeFilterType = itk::ErodeMaskImageFilter<FixedMaskImageType>
using | FixedMaskImagePointer = typename FixedMaskImageType::Pointer
using | FixedMaskImageType = typename ElastixType::FixedMaskType
using | FixedMaskSpatialObjectPointer = typename FixedMaskSpatialObjectType::Pointer
using | FixedMaskSpatialObjectType = itk::ImageMaskSpatialObject<Self::FixedImageDimension>
using | MaskPixelType = typename ElastixType::MaskPixelType
using | MovingImagePyramidType = typename ITKBaseType::MovingImagePyramidType
using | MovingMaskErodeFilterPointer = typename MovingMaskErodeFilterType::Pointer
using | MovingMaskErodeFilterType = itk::ErodeMaskImageFilter<MovingMaskImageType>
using | MovingMaskImagePointer = typename MovingMaskImageType::Pointer
using | MovingMaskImageType = typename ElastixType::MovingMaskType
using | MovingMaskSpatialObjectPointer = typename MovingMaskSpatialObjectType::Pointer
using | MovingMaskSpatialObjectType = itk::ImageMaskSpatialObject<Self::MovingImageDimension>

## Protected Member Functions

| MultiMetricMultiResolutionRegistration ()
virtual void | SetComponents ()
void | UpdateFixedMasks (unsigned int level)
void | UpdateMovingMasks (unsigned int level)
| ~MultiMetricMultiResolutionRegistration () override=default
Protected Member Functions inherited from itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >
virtual void | CheckOnInitialize ()
virtual void | CheckPyramids ()
void | GenerateData () override
void | Initialize () override
| MultiMetricMultiResolutionImageRegistrationMethod ()
virtual void | PrepareAllPyramids ()
void | PrintSelf (std::ostream &os, Indent indent) const override
| ~MultiMetricMultiResolutionImageRegistrationMethod () override=default
Protected Member Functions inherited from itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >
void | GenerateData () override
| MultiResolutionImageRegistrationMethod2 ()
virtual void | PreparePyramids ()
void | PrintSelf (std::ostream &os, Indent indent) const override
virtual void | SetCurrentLevel (unsigned long _arg)
| ~MultiResolutionImageRegistrationMethod2 () override=default
Protected Member Functions inherited from elastix::RegistrationBase< TElastix >
FixedMaskSpatialObjectPointer | GenerateFixedMaskSpatialObject (const FixedMaskImageType *maskImage, bool useMaskErosion, const FixedImagePyramidType *pyramid, unsigned int level) const
MovingMaskSpatialObjectPointer | GenerateMovingMaskSpatialObject (const MovingMaskImageType *maskImage, bool useMaskErosion, const MovingImagePyramidType *pyramid, unsigned int level) const
| RegistrationBase ()=default
| ~RegistrationBase () override=default
Protected Member Functions inherited from elastix::BaseComponentSE< TElastix >
| BaseComponentSE ()=default
| ~BaseComponentSE () override=default
Protected Member Functions inherited from elastix::BaseComponent
| BaseComponent ()=default
virtual | ~BaseComponent ()=default

## Protected Attributes

bool | m_ShowExactMetricValue
Protected Attributes inherited from itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >
CombinationMetricPointer | m_CombinationMetric {}
std::vector< FixedImagePyramidPointer > | m_FixedImagePyramids {}
std::vector< FixedImageRegionPyramidType > | m_FixedImageRegionPyramids {}
std::vector< FixedImageRegionType > | m_FixedImageRegions {}
std::vector< FixedImageConstPointer > | m_FixedImages {}
std::vector< InterpolatorPointer > | m_Interpolators {}
ParametersType | m_LastTransformParameters {}
std::vector< MovingImagePyramidPointer > | m_MovingImagePyramids {}
std::vector< MovingImageConstPointer > | m_MovingImages {}
FixedImageRegionType | m_NullFixedImageRegion {}
bool | m_Stop {}
Protected Attributes inherited from itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >
ParametersType | m_LastTransformParameters {}
bool | m_Stop {}
Protected Attributes inherited from elastix::BaseComponentSE< TElastix >
Configuration::ConstPointer | m_Configuration {}
itk::WeakPointer< TElastix > | m_Elastix {}
RegistrationType * | m_Registration {}

## Private Attributes

| elxOverrideGetSelfMacro

## Member Typedef Documentation

## ConstPointer

template<class TElastix>

using elastix::MultiMetricMultiResolutionRegistration< TElastix >::ConstPointer = itk::SmartPointer<const Self>

Definition at line 114 of file elxMultiMetricMultiResolutionRegistration.h.

## FixedMaskImagePointer

template<class TElastix>

using elastix::RegistrationBase< TElastix >::FixedMaskImagePointer

protected

Definition at line 158 of file elxRegistrationBase.h.

## FixedMaskImageType

template<class TElastix>

using elastix::RegistrationBase< TElastix >::FixedMaskImageType

protected

Definition at line 156 of file elxRegistrationBase.h.

## FixedMaskSpatialObjectPointer

template<class TElastix>

using elastix::RegistrationBase< TElastix >::FixedMaskSpatialObjectPointer

protected

Definition at line 162 of file elxRegistrationBase.h.

## FixedMaskSpatialObjectType

template<class TElastix>

using elastix::RegistrationBase< TElastix >::FixedMaskSpatialObjectType

protected

Definition at line 160 of file elxRegistrationBase.h.

## ITKBaseType

template<class TElastix>

using elastix::MultiMetricMultiResolutionRegistration< TElastix >::ITKBaseType = typename Superclass2::ITKBaseType

Definition at line 175 of file elxMultiMetricMultiResolutionRegistration.h.

## MaskPixelType

template<class TElastix>

using elastix::RegistrationBase< TElastix >::MaskPixelType

protected

Typedef's for mask support.

Definition at line 155 of file elxRegistrationBase.h.

## MovingMaskImagePointer

template<class TElastix>

using elastix::RegistrationBase< TElastix >::MovingMaskImagePointer

protected

Definition at line 159 of file elxRegistrationBase.h.

## MovingMaskImageType

template<class TElastix>

using elastix::RegistrationBase< TElastix >::MovingMaskImageType

protected

Definition at line 157 of file elxRegistrationBase.h.

## MovingMaskSpatialObjectPointer

template<class TElastix>

using elastix::RegistrationBase< TElastix >::MovingMaskSpatialObjectPointer

protected

Definition at line 163 of file elxRegistrationBase.h.

## MovingMaskSpatialObjectType

template<class TElastix>

using elastix::RegistrationBase< TElastix >::MovingMaskSpatialObjectType

protected

Definition at line 161 of file elxRegistrationBase.h.

## Pointer

template<class TElastix>

using elastix::MultiMetricMultiResolutionRegistration< TElastix >::Pointer = itk::SmartPointer<Self>

Standard ITK: SmartPointers

Definition at line 113 of file elxMultiMetricMultiResolutionRegistration.h.

## RegistrationType

template<class TElastix>

using elastix::MultiMetricMultiResolutionRegistration< TElastix >::RegistrationType = typename Superclass2::RegistrationType

Definition at line 174 of file elxMultiMetricMultiResolutionRegistration.h.

## Self

template<class TElastix>

using elastix::MultiMetricMultiResolutionRegistration< TElastix >::Self = MultiMetricMultiResolutionRegistration

Standard ITK: Self

Definition at line 104 of file elxMultiMetricMultiResolutionRegistration.h.

## Superclass1

template<class TElastix>

using elastix::MultiMetricMultiResolutionRegistration< TElastix >::Superclass1

Initial value:
itk::MultiMetricMultiResolutionImageRegistrationMethod<typename RegistrationBase<TElastix>::FixedImageType,
typename RegistrationBase<TElastix>::MovingImageType>
elastix::RegistrationBase::MovingImageType
typename ElastixType::MovingImageType MovingImageType
Definition elxRegistrationBase.h:93
itk::MultiMetricMultiResolutionImageRegistrationMethod
Base class for multi-resolution image registration methods.
Definition itkMultiMetricMultiResolutionImageRegistrationMethod.h:79

Standard ITK: Superclasses.

Definition at line 107 of file elxMultiMetricMultiResolutionRegistration.h.

## Superclass2

template<class TElastix>

using elastix::MultiMetricMultiResolutionRegistration< TElastix >::Superclass2 = RegistrationBase<TElastix>

Definition at line 110 of file elxMultiMetricMultiResolutionRegistration.h.

## UseMaskErosionArrayType

template<class TElastix>

using elastix::RegistrationBase< TElastix >::UseMaskErosionArrayType

Typedef for mask erosion options

Definition at line 104 of file elxRegistrationBase.h.

## Constructor & Destructor Documentation

## MultiMetricMultiResolutionRegistration()

template<class TElastix>

elastix::MultiMetricMultiResolutionRegistration< TElastix >::MultiMetricMultiResolutionRegistration | ( |  | ) |

protected

The constructor.

## ~MultiMetricMultiResolutionRegistration()

template<class TElastix>

elastix::MultiMetricMultiResolutionRegistration< TElastix >::~MultiMetricMultiResolutionRegistration | ( |  | ) |

override protected default

The destructor.

## Member Function Documentation

## AfterEachIteration()

template<class TElastix>

void elastix::MultiMetricMultiResolutionRegistration< TElastix >::AfterEachIteration | ( |  | ) |

override virtual

Execute stuff after each iteration

- Print the latest computed submetric values to screen.

Reimplemented from elastix::BaseComponent.

## BeforeEachResolution()

template<class TElastix>

void elastix::MultiMetricMultiResolutionRegistration< TElastix >::BeforeEachResolution | ( |  | ) |

override virtual

Execute stuff before each resolution:

- Update masks with an erosion.
- Set the metric weights.

Reimplemented from elastix::BaseComponent.

## BeforeRegistration()

template<class TElastix>

void elastix::MultiMetricMultiResolutionRegistration< TElastix >::BeforeRegistration | ( |  | ) |

override virtual

Execute stuff before the actual registration:

- Connect all components to the registration framework.
- Set the number of resolution levels.
- Set the fixed image regions.
- Add the sub metric columns to the iteration info object.

Reimplemented from elastix::BaseComponent.

## elxClassNameMacro()

template<class TElastix>

elastix::MultiMetricMultiResolutionRegistration< TElastix >::elxClassNameMacro | ( | "MultiMetricMultiResolutionRegistration< TElastix >" |  | ) |

Name of this class. Use this name in the parameter file to select this specific registration framework.
example: (Registration "MultiMetricMultiResolutionRegistration")

## GetClassName()

template<class TElastix>

virtual const char * elastix::MultiMetricMultiResolutionRegistration< TElastix >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented from itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >.

## ITK_DISALLOW_COPY_AND_MOVE()

template<class TElastix>

elastix::MultiMetricMultiResolutionRegistration< TElastix >::ITK_DISALLOW_COPY_AND_MOVE | ( | MultiMetricMultiResolutionRegistration< TElastix > |  | ) |

## itkStaticConstMacro() [1/2]

template<class TElastix>

elastix::MultiMetricMultiResolutionRegistration< TElastix >::itkStaticConstMacro | ( | FixedImageDimension | ,
|  | unsigned int | ,
|  | Superclass2::FixedImageDimension | )

Get the dimension of the fixed image.

## itkStaticConstMacro() [2/2]

template<class TElastix>

elastix::MultiMetricMultiResolutionRegistration< TElastix >::itkStaticConstMacro | ( | MovingImageDimension | ,
|  | unsigned int | ,
|  | Superclass2::MovingImageDimension | )

Get the dimension of the moving image.

## New()

template<class TElastix>

Pointer elastix::MultiMetricMultiResolutionRegistration< TElastix >::New | ( |  | ) |

static

Method for creation through the object factory.

## SetComponents()

template<class TElastix>

virtual void elastix::MultiMetricMultiResolutionRegistration< TElastix >::SetComponents | ( |  | ) |

protected virtual

Read the components from m_Elastix and set them in the Registration class.

## UpdateFixedMasks()

template<class TElastix>

void elastix::MultiMetricMultiResolutionRegistration< TElastix >::UpdateFixedMasks | ( | unsigned int | level | ) |

protected

Function to update masks.

## UpdateMovingMasks()

template<class TElastix>

void elastix::MultiMetricMultiResolutionRegistration< TElastix >::UpdateMovingMasks | ( | unsigned int | level | ) |

protected

## Field Documentation

## elxOverrideGetSelfMacro

template<class TElastix>

elastix::MultiMetricMultiResolutionRegistration< TElastix >::elxOverrideGetSelfMacro

private

Definition at line 236 of file elxMultiMetricMultiResolutionRegistration.h.

## m_ShowExactMetricValue

template<class TElastix>

bool elastix::MultiMetricMultiResolutionRegistration< TElastix >::m_ShowExactMetricValue

protected

Definition at line 233 of file elxMultiMetricMultiResolutionRegistration.h.

Generated on 1768596610 for elastix by 1.15.0 |